<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html 
     PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
     "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
  <title>Class: FontDB</title>
  <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
  <meta http-equiv="Content-Script-Type" content="text/javascript" />
  <link rel="stylesheet" href=".././rdoc-style.css" type="text/css" media="screen" />
  <script type="text/javascript">
  // <![CDATA[

  function popupCode( url ) {
    window.open(url, "Code", "resizable=yes,scrollbars=yes,toolbar=no,status=no,height=150,width=400")
  }

  function toggleCode( id ) {
    if ( document.getElementById )
      elem = document.getElementById( id );
    else if ( document.all )
      elem = eval( "document.all." + id );
    else
      return false;

    elemStyle = elem.style;
    
    if ( elemStyle.display != "block" ) {
      elemStyle.display = "block"
    } else {
      elemStyle.display = "none"
    }

    return true;
  }
  
  // Make codeblocks hidden by default
  document.writeln( "<style type=\"text/css\">div.method-source-code { display: none }</style>" )
  
  // ]]>
  </script>

</head>
<body>



    <div id="classHeader">
        <table class="header-table">
        <tr class="top-aligned-row">
          <td><strong>Class</strong></td>
          <td class="class-name-in-header">FontDB</td>
        </tr>
        <tr class="top-aligned-row">
            <td><strong>In:</strong></td>
            <td>
                <a href="../files/font_db_rb.html">
                font_db.rb
                </a>
        <br />
            </td>
        </tr>

        <tr class="top-aligned-row">
            <td><strong>Parent:</strong></td>
            <td>
                Object
            </td>
        </tr>
        </table>
    </div>
  <!-- banner header -->

  <div id="bodyContent">



  <div id="contextContent">

    <div id="description">
      <p>
Create and access a database of fonts. The instance is accessed using
FontDB.instance()
</p>

    </div>


   </div>

    <div id="method-list">
      <h3 class="section-bar">Methods</h3>

      <div class="name-list">
      <a href="#M000005">add_font</a>&nbsp;&nbsp;
      <a href="#M000010">add_sets</a>&nbsp;&nbsp;
      <a href="#M000009">add_tags</a>&nbsp;&nbsp;
      <a href="#M000021">auto_tag</a>&nbsp;&nbsp;
      <a href="#M000022">auto_tag_font</a>&nbsp;&nbsp;
      <a href="#M000014">combine_sets</a>&nbsp;&nbsp;
      <a href="#M000013">combine_tags</a>&nbsp;&nbsp;
      <a href="#M000003">create_tables</a>&nbsp;&nbsp;
      <a href="#M000004">drop_tables</a>&nbsp;&nbsp;
      <a href="#M000002">get</a>&nbsp;&nbsp;
      <a href="#M000001">new</a>&nbsp;&nbsp;
      <a href="#M000006">populate</a>&nbsp;&nbsp;
      <a href="#M000016">read_sets</a>&nbsp;&nbsp;
      <a href="#M000015">read_tags</a>&nbsp;&nbsp;
      <a href="#M000012">remove_sets</a>&nbsp;&nbsp;
      <a href="#M000011">remove_tags</a>&nbsp;&nbsp;
      <a href="#M000018">set_members</a>&nbsp;&nbsp;
      <a href="#M000020">sets</a>&nbsp;&nbsp;
      <a href="#M000008">tables_exist?</a>&nbsp;&nbsp;
      <a href="#M000017">tag_members</a>&nbsp;&nbsp;
      <a href="#M000019">tags</a>&nbsp;&nbsp;
      <a href="#M000007">to_s</a>&nbsp;&nbsp;
      </div>
    </div>

  </div>


    <!-- if includes -->
    <div id="includes">
      <h3 class="section-bar">Included Modules</h3>

      <div id="includes-list">
        <span class="include-name">Singleton</span>
      </div>
    </div>

    <div id="section">


    <div id="constants-list">
      <h3 class="section-bar">Constants</h3>

      <div class="name-list">
        <table summary="Constants">
        <tr class="top-aligned-row context-row">
          <td class="context-item-name">UP</td>
          <td>=</td>
          <td class="context-item-value">true</td>
          <td width="3em">&nbsp;</td>
          <td class="context-item-desc">
FIXME: Where should they go?

</td>
        </tr>
        <tr class="top-aligned-row context-row">
          <td class="context-item-name">DOWN</td>
          <td>=</td>
          <td class="context-item-value">false</td>
        </tr>
        <tr class="top-aligned-row context-row">
          <td class="context-item-name">NO_LIMIT</td>
          <td>=</td>
          <td class="context-item-value">-1</td>
        </tr>
        <tr class="top-aligned-row context-row">
          <td class="context-item-name">FONT_DIRECTORIES</td>
          <td>=</td>
          <td class="context-item-value">['/usr/share/fonts','C:\WINDOWS\Fonts']</td>
          <td width="3em">&nbsp;</td>
          <td class="context-item-desc">
FIXME: Get this stuff from a textfile or something.

</td>
        </tr>
        <tr class="top-aligned-row context-row">
          <td class="context-item-name">FONT_TYPES</td>
          <td>=</td>
          <td class="context-item-value">[&quot;ttf&quot;,&quot;otf&quot;]</td>
        </tr>
        <tr class="top-aligned-row context-row">
          <td class="context-item-name">AUTO_TAGS</td>
          <td>=</td>
          <td class="context-item-value">%w(bold serif italic sans-serif                  sans\ serif hairline modern slab\ serif script)</td>
          <td width="3em">&nbsp;</td>
          <td class="context-item-desc">
Add these <a href="FontDB.html#M000019">tags</a> based on font metadata.

</td>
        </tr>
        <tr class="top-aligned-row context-row">
          <td class="context-item-name">AUTO_TAGS_EXCLUSIVE</td>
          <td>=</td>
          <td class="context-item-value">{&quot;sans-serif&quot; =&gt; &quot;serif&quot;, &quot;sans serif&quot; =&gt; &quot;serif&quot;}</td>
          <td width="3em">&nbsp;</td>
          <td class="context-item-desc">
The associated data cannot coexist. The right side is removed.

</td>
        </tr>
        <tr class="top-aligned-row context-row">
          <td class="context-item-name">AUTO_TAGS_COMBINE</td>
          <td>=</td>
          <td class="context-item-value">{&quot;sans-serif&quot; =&gt; &quot;sans serif&quot;}</td>
          <td width="3em">&nbsp;</td>
          <td class="context-item-desc">
The associated data should be combined. Left side becomes right side.

</td>
        </tr>
        <tr class="top-aligned-row context-row">
          <td class="context-item-name">AUTO_TAGS_COLUMNS</td>
          <td>=</td>
          <td class="context-item-value">%w(family subfamily name description)</td>
          <td width="3em">&nbsp;</td>
          <td class="context-item-desc">
Columns to search through for <a href="FontDB.html#M000019">tags</a>.

</td>
        </tr>
        </table>
      </div>
    </div>



      


    <!-- if method_list -->
    <div id="methods">
      <h3 class="section-bar">Public Class methods</h3>

      <div id="method-M000001" class="method-detail">
        <a name="M000001"></a>

        <div class="method-heading">
          <a href="FontDB.src/M000001.html" target="Code" class="method-signature"
            onclick="popupCode('FontDB.src/M000001.html');return false;">
          <span class="method-name">new</span><span class="method-args">()</span>
          </a>
        </div>
      
        <div class="method-description">
        </div>
      </div>

      <h3 class="section-bar">Public Instance methods</h3>

      <div id="method-M000005" class="method-detail">
        <a name="M000005"></a>

        <div class="method-heading">
          <a href="FontDB.src/M000005.html" target="Code" class="method-signature"
            onclick="popupCode('FontDB.src/M000005.html');return false;">
          <span class="method-name">add_font</span><span class="method-args">(path)</span>
          </a>
        </div>
      
        <div class="method-description">
          <p>
Adds a font to the database. FIXME: This should <a
href="FontDB.html#M000022">auto_tag_font</a>.
</p>
        </div>
      </div>

      <div id="method-M000010" class="method-detail">
        <a name="M000010"></a>

        <div class="method-heading">
          <a href="FontDB.src/M000010.html" target="Code" class="method-signature"
            onclick="popupCode('FontDB.src/M000010.html');return false;">
          <span class="method-name">add_sets</span><span class="method-args">(font_ids, set)</span>
          </a>
        </div>
      
        <div class="method-description">
          <p>
Adds the <a href="FontDB.html#M000020">sets</a> to the given fonts.
</p>
        </div>
      </div>

      <div id="method-M000009" class="method-detail">
        <a name="M000009"></a>

        <div class="method-heading">
          <a href="FontDB.src/M000009.html" target="Code" class="method-signature"
            onclick="popupCode('FontDB.src/M000009.html');return false;">
          <span class="method-name">add_tags</span><span class="method-args">(font_ids, tags)</span>
          </a>
        </div>
      
        <div class="method-description">
          <p>
Adds the <a href="FontDB.html#M000019">tags</a> to the given fonts.
</p>
        </div>
      </div>

      <div id="method-M000021" class="method-detail">
        <a name="M000021"></a>

        <div class="method-heading">
          <a href="FontDB.src/M000021.html" target="Code" class="method-signature"
            onclick="popupCode('FontDB.src/M000021.html');return false;">
          <span class="method-name">auto_tag</span><span class="method-args">(auto_tags, auto_tags_exclusive, auto_tags_combine, auto_tags_search_columns)</span>
          </a>
        </div>
      
        <div class="method-description">
          <p>
Automatically <a href="FontDB.html#M000019">tags</a> all fonts. FIXME:
should constants be in here?
</p>
        </div>
      </div>

      <div id="method-M000022" class="method-detail">
        <a name="M000022"></a>

        <div class="method-heading">
          <a href="FontDB.src/M000022.html" target="Code" class="method-signature"
            onclick="popupCode('FontDB.src/M000022.html');return false;">
          <span class="method-name">auto_tag_font</span><span class="method-args">(id, auto_tags, auto_tags_exclusive, auto_tags_combine, auto_tags_search_columns)</span>
          </a>
        </div>
      
        <div class="method-description">
          <p>
<a href="FontDB.html#M000021">auto_tag</a> one font.
</p>
        </div>
      </div>

      <div id="method-M000014" class="method-detail">
        <a name="M000014"></a>

        <div class="method-heading">
          <a href="FontDB.src/M000014.html" target="Code" class="method-signature"
            onclick="popupCode('FontDB.src/M000014.html');return false;">
          <span class="method-name">combine_sets</span><span class="method-args">(new_set, *old_sets)</span>
          </a>
        </div>
      
        <div class="method-description">
          <p>
Changes all old_sets to new_set.
</p>
        </div>
      </div>

      <div id="method-M000013" class="method-detail">
        <a name="M000013"></a>

        <div class="method-heading">
          <a href="FontDB.src/M000013.html" target="Code" class="method-signature"
            onclick="popupCode('FontDB.src/M000013.html');return false;">
          <span class="method-name">combine_tags</span><span class="method-args">(new_tag, *old_tags)</span>
          </a>
        </div>
      
        <div class="method-description">
          <p>
Changes all old_tags to new_tag.
</p>
        </div>
      </div>

      <div id="method-M000003" class="method-detail">
        <a name="M000003"></a>

        <div class="method-heading">
          <a href="FontDB.src/M000003.html" target="Code" class="method-signature"
            onclick="popupCode('FontDB.src/M000003.html');return false;">
          <span class="method-name">create_tables</span><span class="method-args">()</span>
          </a>
        </div>
      
        <div class="method-description">
          <p>
Creates the required tables.
</p>
        </div>
      </div>

      <div id="method-M000004" class="method-detail">
        <a name="M000004"></a>

        <div class="method-heading">
          <a href="FontDB.src/M000004.html" target="Code" class="method-signature"
            onclick="popupCode('FontDB.src/M000004.html');return false;">
          <span class="method-name">drop_tables</span><span class="method-args">()</span>
          </a>
        </div>
      
        <div class="method-description">
          <p>
Removes all tables from the database.
</p>
        </div>
      </div>

      <div id="method-M000002" class="method-detail">
        <a name="M000002"></a>

        <div class="method-heading">
          <a href="FontDB.src/M000002.html" target="Code" class="method-signature"
            onclick="popupCode('FontDB.src/M000002.html');return false;">
          <span class="method-name">get</span><span class="method-args">(columns, order_by='name', sort_dir = UP, limit = NO_LIMIT, offset = 0)</span>
          </a>
        </div>
      
        <div class="method-description">
          <p>
Gets data out of the database. For example
</p>
<p>
FontDB.instance.<a
href="FontDB.html#M000002">get</a>(&quot;name&quot;,&quot;id&quot;,DOWN, 5,
10)
</p>
<p>
will display the names, sorted by decreasing ID starting at 10, and going
to number 15
</p>
        </div>
      </div>

      <div id="method-M000006" class="method-detail">
        <a name="M000006"></a>

        <div class="method-heading">
          <a href="FontDB.src/M000006.html" target="Code" class="method-signature"
            onclick="popupCode('FontDB.src/M000006.html');return false;">
          <span class="method-name">populate</span><span class="method-args">()</span>
          </a>
        </div>
      
        <div class="method-description">
          <p>
Populates the table based on system directories.
</p>
        </div>
      </div>

      <div id="method-M000016" class="method-detail">
        <a name="M000016"></a>

        <div class="method-heading">
          <a href="FontDB.src/M000016.html" target="Code" class="method-signature"
            onclick="popupCode('FontDB.src/M000016.html');return false;">
          <span class="method-name">read_sets</span><span class="method-args">(font_id)</span>
          </a>
        </div>
      
        <div class="method-description">
          <p>
Lists all of the given font&#8216;s <a href="FontDB.html#M000020">sets</a>.
</p>
        </div>
      </div>

      <div id="method-M000015" class="method-detail">
        <a name="M000015"></a>

        <div class="method-heading">
          <a href="FontDB.src/M000015.html" target="Code" class="method-signature"
            onclick="popupCode('FontDB.src/M000015.html');return false;">
          <span class="method-name">read_tags</span><span class="method-args">(font_id)</span>
          </a>
        </div>
      
        <div class="method-description">
          <p>
Lists all of the given font&#8216;s <a href="FontDB.html#M000019">tags</a>.
</p>
        </div>
      </div>

      <div id="method-M000012" class="method-detail">
        <a name="M000012"></a>

        <div class="method-heading">
          <a href="FontDB.src/M000012.html" target="Code" class="method-signature"
            onclick="popupCode('FontDB.src/M000012.html');return false;">
          <span class="method-name">remove_sets</span><span class="method-args">(font_ids, tags)</span>
          </a>
        </div>
      
        <div class="method-description">
          <p>
Removes the <a href="FontDB.html#M000020">sets</a> from the given fonts.
</p>
        </div>
      </div>

      <div id="method-M000011" class="method-detail">
        <a name="M000011"></a>

        <div class="method-heading">
          <a href="FontDB.src/M000011.html" target="Code" class="method-signature"
            onclick="popupCode('FontDB.src/M000011.html');return false;">
          <span class="method-name">remove_tags</span><span class="method-args">(font_ids, tags)</span>
          </a>
        </div>
      
        <div class="method-description">
          <p>
Removes the <a href="FontDB.html#M000019">tags</a> from the given fonts.
</p>
        </div>
      </div>

      <div id="method-M000018" class="method-detail">
        <a name="M000018"></a>

        <div class="method-heading">
          <a href="FontDB.src/M000018.html" target="Code" class="method-signature"
            onclick="popupCode('FontDB.src/M000018.html');return false;">
          <span class="method-name">set_members</span><span class="method-args">(set_name)</span>
          </a>
        </div>
      
        <div class="method-description">
          <p>
Lists all of the set&#8216;s members.
</p>
        </div>
      </div>

      <div id="method-M000020" class="method-detail">
        <a name="M000020"></a>

        <div class="method-heading">
          <a href="FontDB.src/M000020.html" target="Code" class="method-signature"
            onclick="popupCode('FontDB.src/M000020.html');return false;">
          <span class="method-name">sets</span><span class="method-args">()</span>
          </a>
        </div>
      
        <div class="method-description">
          <p>
Lists all <a href="FontDB.html#M000020">sets</a>.
</p>
        </div>
      </div>

      <div id="method-M000008" class="method-detail">
        <a name="M000008"></a>

        <div class="method-heading">
          <a href="FontDB.src/M000008.html" target="Code" class="method-signature"
            onclick="popupCode('FontDB.src/M000008.html');return false;">
          <span class="method-name">tables_exist?</span><span class="method-args">()</span>
          </a>
        </div>
      
        <div class="method-description">
          <p>
Has <a href="FontDB.html#M000003">create_tables</a> been called?
</p>
        </div>
      </div>

      <div id="method-M000017" class="method-detail">
        <a name="M000017"></a>

        <div class="method-heading">
          <a href="FontDB.src/M000017.html" target="Code" class="method-signature"
            onclick="popupCode('FontDB.src/M000017.html');return false;">
          <span class="method-name">tag_members</span><span class="method-args">(tag_name)</span>
          </a>
        </div>
      
        <div class="method-description">
          <p>
Lists all of the tag&#8216;s members.
</p>
        </div>
      </div>

      <div id="method-M000019" class="method-detail">
        <a name="M000019"></a>

        <div class="method-heading">
          <a href="FontDB.src/M000019.html" target="Code" class="method-signature"
            onclick="popupCode('FontDB.src/M000019.html');return false;">
          <span class="method-name">tags</span><span class="method-args">()</span>
          </a>
        </div>
      
        <div class="method-description">
          <p>
Lists all <a href="FontDB.html#M000019">tags</a>.
</p>
        </div>
      </div>

      <div id="method-M000007" class="method-detail">
        <a name="M000007"></a>

        <div class="method-heading">
          <a href="FontDB.src/M000007.html" target="Code" class="method-signature"
            onclick="popupCode('FontDB.src/M000007.html');return false;">
          <span class="method-name">to_s</span><span class="method-args">()</span>
          </a>
        </div>
      
        <div class="method-description">
          <table>
<tr><td valign="top">FIXME:</td><td>add in <a href="FontDB.html#M000020">sets</a>.

</td></tr>
</table>
        </div>
      </div>


    </div>


  </div>


<div id="validator-badges">
  <p><small><a href="http://validator.w3.org/check/referer">[Validate]</a></small></p>
</div>

</body>
</html>